(* ------------------------- DOTLINE.INC ----------------------------- *)
(*  Include-File fuer Grafikbefehle auf dem JOYCE unter Turbo Pascal.  *)
(*  Hauptmodul, enthaelt MCode und elementare Routinen. Muss auf alle  *)
(*  Faelle ins Hauptprogramm eingebinden werden.                       *)
(*  Es sind enthalten:                                                 *)
(*                                                                     *)
(*     procedure GraphInit           -> Initialisierung des MCode      *)
(*     procedure Plot(x,y,m)         -> Pixel set/reset/invert         *)
(*     procedure Line(x0,y0,x1,y1,m) -> Linie zeichnen                 *)
(*     procedure Screen_On           -> Bildschirm einschalten         *)
(*     procedure Screen_Off          -> Bildschirm ausschalten         *)
(*     procedure ShowCursor          -> Cursor ein                     *)
(*     procedure HideCursor          -> Cursor aus                     *)
(*                                                                     *)
(*   Variablen & Prozeduren mit dem Namen GX_ sind zu vermeiden, um    *)
(*   nicht mit Interna der Grafikerweiterungen zu kollidieren.         *)
(*                                                                     *)
(*   Zum Compilieren die Endadresse auf $F3FF setzen, um nicht den     *)
(*   MCode zu ueberschreiben!                                          *)
(* ------------------------------------------------------------------- *)

type GX_MCode = array(.0..443.) of byte;

var  GX_MProg: GX_MCode absolute $F400;

const GX_Data:GX_MCode =
  ($01,$09,$F4,$CD,$5A,$FC,$E9,$00,$C9,$ED,$5B,$5E,$F4,$2A,$60,$F4,
   $3E,$03,$A2,$57,$E5,$26,$00,$29,$01,$00,$B6,$09,$4E,$23,$46,$79,
   $E6,$F8,$6F,$60,$29,$19,$7D,$E6,$F8,$6F,$79,$E6,$07,$B5,$6F,$7B,
   $E6,$07,$3C,$47,$AF,$37,$1F,$10,$FD,$C1,$4F,$78,$FE,$00,$20,$04,
   $79,$B6,$77,$C9,$FE,$01,$20,$05,$79,$2F,$A6,$77,$C9,$FE,$02,$20,
   $04,$79,$AE,$77,$C9,$FE,$03,$C0,$79,$A6,$32,$62,$F4,$C9,$00,$00,
   $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
   $00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$82,$F4,$CD,$5A,$FC,$E9,
   $00,$C9,$ED,$5B,$63,$F4,$ED,$53,$67,$F4,$2A,$63,$F4,$ED,$5B,$5E,
   $F4,$B7,$ED,$52,$22,$6B,$F4,$ED,$5B,$65,$F4,$ED,$53,$69,$F4,$2A,
   $65,$F4,$ED,$5B,$60,$F4,$B7,$ED,$52,$22,$6D,$F4,$21,$01,$00,$22,
   $75,$F4,$22,$77,$F4,$3A,$6C,$F4,$CB,$7F,$28,$13,$21,$FF,$FF,$22,
   $75,$F4,$21,$00,$00,$ED,$5B,$6B,$F4,$B7,$ED,$52,$22,$6B,$F4,$3A,
   $6E,$F4,$CB,$7F,$28,$13,$21,$FF,$FF,$22,$77,$F4,$21,$00,$00,$ED,
   $5B,$6D,$F4,$B7,$ED,$52,$22,$6D,$F4,$2A,$6B,$F4,$29,$22,$6F,$F4,
   $2A,$6D,$F4,$29,$22,$71,$F4,$2A,$6D,$F4,$ED,$5B,$6B,$F4,$13,$B7,
   $ED,$52,$38,$03,$C3,$61,$F5,$ED,$5B,$6B,$F4,$21,$00,$00,$B7,$ED,
   $52,$22,$73,$F4,$2A,$5E,$F4,$ED,$5B,$67,$F4,$B7,$ED,$52,$7C,$B5,
   $28,$3C,$CD,$09,$F4,$ED,$5B,$73,$F4,$2A,$71,$F4,$19,$22,$73,$F4,
   $CB,$7C,$20,$1C,$7C,$B5,$28,$18,$2A,$73,$F4,$ED,$5B,$6F,$F4,$B7,
   $ED,$52,$22,$73,$F4,$2A,$60,$F4,$ED,$5B,$77,$F4,$19,$22,$60,$F4,
   $2A,$5E,$F4,$ED,$5B,$75,$F4,$19,$22,$5E,$F4,$C3,$14,$F5,$C3,$B8,
   $F5,$21,$00,$00,$ED,$5B,$6D,$F4,$B7,$ED,$52,$22,$73,$F4,$2A,$60,
   $F4,$ED,$5B,$69,$F4,$B7,$ED,$52,$7C,$B5,$28,$3C,$CD,$09,$F4,$2A,
   $73,$F4,$ED,$5B,$6F,$F4,$19,$22,$73,$F4,$CB,$7C,$20,$1C,$7D,$B4,
   $28,$18,$2A,$73,$F4,$ED,$5B,$71,$F4,$B7,$ED,$52,$22,$73,$F4,$2A,
   $5E,$F4,$ED,$5B,$75,$F4,$19,$22,$5E,$F4,$2A,$60,$F4,$ED,$5B,$77,
   $F4,$19,$22,$60,$F4,$C3,$6E,$F5,$CD,$09,$F4,$C9);


PROCEDURE GX_Dot; external $F400;

PROCEDURE GX_Line; external $F479;


PROCEDURE GraphInit;
begin
  GX_MProg:=GX_Data;
end;


PROCEDURE Plot(x: integer; y, m: byte);
var  GX_X: integer absolute $F45E;
     GX_Y: byte    absolute $F460;
     GX_M: byte    absolute $F462;
begin
  GX_X:=x;
  GX_Y:=y;
  GX_M:=m;
  GX_Dot;
end;

PROCEDURE Line(x0, y0, x1, y1: integer; m: byte);
var  GX_X0: integer absolute $F45E;
     GX_Y0: integer absolute $F460;
     GX_M:  byte    absolute $F462;
     GX_X1: integer absolute $F463;
     GX_Y1: integer absolute $F465;
begin
  GX_X0:=x0;
  GX_Y0:=y0;
  GX_X1:=x1;
  GX_Y1:=y1;
  GX_M:=m;
  GX_Line;
end;

PROCEDURE Screen_On;
begin
  port(.248.):=7;
end;

PROCEDURE Screen_Off;
begin
  port(.248.):=8;
end;

PROCEDURE HideCursor;
begin
 write(#27,'f');
end;

PROCEDURE ShowCursor;
begin
  write(#27,'e');
end;

(* ------------------ Ende von DOTLINE.INC ---------------------- *)
